{%- from "shuup/front/macros/general.jinja" import render_supplier_info -%}
{%- from "canvas/macros/wishlist_button.jinja" import get_wishlist_button with context %}

{% macro render_basket_partial(basket=None) %}
    {% if show_prices() and not xtheme.get("hide_prices") %}

        {# This is only used to get the basket product count to navigation elements #}
        <div class="hidden" id="basket-product-count">{% if basket.product_count > 0 %}{{ basket.product_count }}{% endif %}</div>

        <div class="mb-5">
            <h2 class="mt-0">{% trans %}Tote Bag{% endtrans %} <span id="tote-bag-count">({{ basket.product_count }})</span></h2>
        </div>

        {% if basket.is_empty and not basket.get_unorderable_lines() %}
            <p class="lead text-muted mt-4">
                {% trans %}Your tote bag is empty.{% endtrans %}
            </p>
        {% else %}
            {% if errors %}
                <p class="text-danger">
                    {% trans %}There were errors on following items{% endtrans %}:
                </p>
                {% for error in errors %}
                    <p>{{ error.message }}</p>
                {% endfor %}
                <hr>
            {% endif %}

            {{ render_basket_content(basket) }}

            {% if errors %}
                <p class="lead my-5">
                    <i class="fa fa-exclamation-triangle text-danger"></i>
                    {% trans %}You are unable to proceed to checkout!{% endtrans %}
                </p>
            {% else %}
                {{ proceed_to_checkout_button() }}
            {% endif %}

            {{ render_cart_saver() }}
        {% endif %}
    {% endif %}
{% endmacro %}

{% macro render_basket_content(basket) %}
    <div class="basket-items py-3">
        <form method="post" action="{{ url('shuup:basket') }}" id="update_basket_form">
            <input name="command" type="hidden" value="update">
            <input name="return" type="hidden" value="{{ request.path }}">
            {% csrf_token %}
            {{ render_basket_lines(basket) }}
            {{ render_unorderable_basket_lines(basket) }}
        </form>
        {{ render_used_coupons(basket) }}
        {{ render_coupon_div(basket) }}
        {{ render_basket_summary(basket) }}
    </div>
{% endmacro %}

{% macro render_basket_lines(basket) %}
    {% set lines = basket.get_final_lines() %}
    {% if lines|length %}
        <div class="basket-lines">
        {% if xtheme.get("group_items_by_supplier") %}
            {% set groupped_lines = xtheme.group_lines_by_supplier(lines) %}
            {% for supplier, lines in groupped_lines.items() %}
                <div class="basket-line supplier-info">
                    {%- if supplier -%}
                        {{- render_basket_supplier_info(supplier) -}}
                    {%- endif -%}
                </div>
                {% for line in lines %}
                    <div class="basket-line">
                        {{ _render_basket_line(line) }}
                    </div>
                {% endfor %}
            {% endfor %}
        {% else %}
            {% for line in lines %}
                <div class="basket-line">
                    {{ _render_basket_line(line) }}
                </div>
            {% endfor %}
        {% endif %}
        </div>
    {% endif %}
{% endmacro %}

{% macro render_unorderable_basket_lines(basket) %}
    {% set unorderable_lines = basket.get_unorderable_lines() %}
    {% if unorderable_lines %}
        <p class="text-danger">{% trans %}The following items are not currently available (or are not available in the desired quantity) and cannot be included in your order.{% endtrans %}</p>
        <div class="basket-lines">
            {% if xtheme.get("group_items_by_supplier") %}
                {% set groupped_lines = xtheme.group_lines_by_supplier(unorderable_lines) %}
                {% for supplier, lines in groupped_lines.items() %}
                    <div class="basket-line supplier-info">
                        {%- if supplier -%}
                            {{- render_basket_supplier_info(supplier) -}}
                        {%- endif -%}
                    </div>
                    {% for line in lines %}
                        <div class="basket-line">
                            {{ _render_basket_line(line) }}
                        </div>
                    {% endfor %}
                {% endfor %}
            {% else %}
                {% for line in unorderable_lines %}
                    <div class="basket-line">
                        {{ _render_basket_line(line) }}
                    </div>
                {% endfor %}
            {% endif %}
        </div>
    {% endif %}
{% endmacro %}

{% macro _render_basket_line(line) %}
    {% set product = line.product %}
    {% set shop_product = line.shop_product %}
    {% if product %}
        <div class="basket-line__product-image">
            {% set image = product.primary_image %}
            {% if not image and product.is_variation_child() %}
                {% set image = product.variation_parent.primary_image %}
                {% set product_url = shuup.urls.model_url(product.variation_parent) %}
            {% else %}
                {% set product_url = shuup.urls.model_url(product) %}
            {% endif %}
            {% if image %}
                <a href="{{ product_url }}">
                    <img class="img-responsive" src="{{ image|thumbnail(size=(200, 200)) }}" alt="{{ line.text }}">
                </a>
            {% else %}
                <a href="{{ product_url }}">
                    <img class="img-responsive" src="{{ STATIC_URL }}shuup/front/img/no_image_thumbnail.png">
                </a>
            {% endif %}
        </div>
    {% endif %}
    <div class="basket-line__details">
        <div class="basket-line__details-cell upper-cell">
            <div class="basket-line__cell name">
                {% if product %}
                    {% if line.supplier %}{{ _render_supplier_info(line.supplier) }}{% endif %}
                    <h3 class="h4">
                        <a class="product-name" href="{{ shuup.urls.model_url(product) }}">
                            {{ line.text }}
                        </a>
                    </h3>
                {% else %}
                    <h3 class="h4">{{ line.type.label|title }}: {{ line.text }}</h3>
                {% endif %}
            </div>

            <div class="basket-line__cell price">
                {% if show_prices() and not xtheme.get("hide_prices") %}
                    {% if line.is_discounted and line.base_price.value > 0 %}
                        <small class="text-muted"><s>{{ line|base_unit_price(allow_cache=False) }}</s></small>
                        {{ line|discounted_unit_price(allow_cache=False) }}
                    {% else %}
                        {{ line|base_unit_price(allow_cache=False) }}
                    {% endif %}
                {% endif %}
            </div>
        </div>

        {% set line_properties = shuup.basket.get_properties_from_line(line) %}
        {% if line_properties %}
            {{ render_basket_line_properties(line_properties) }}
        {% endif %}

        <div class="basket-line__row">
            <div class="basket-line__cell quantity">
                {% if product %}
                    {% if line.can_change_quantity %}
                        <div class="basket-quantity">
                            {# TODO: Add functionality for +/- buttons #}
                            <button class="basket-quantity__minus" type="button" aria-label="{% trans %}Decrease quantity{% endtrans %}">
                                <svg viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg" aria-hidden="true">
                                <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                                </svg>
                            </button>
                            <input
                                id="qty_{{ line.line_id }}"
                                type="number"
                                name="q_{{ line.line_id }}"
                                size="2"
                                class="line_quantity"
                                step="{{ shop_product.quantity_step }}"
                                value="{{ line.quantity }}"
                                min="{{ shop_product.rounded_minimum_purchase_quantity }}">
                            <button class="basket-quantity__plus" type="button" aria-label="{% trans %}Increase quantity{% endtrans %}">
                                <svg viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg" aria-hidden="true">
                                <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                                <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                                </svg>
                            </button>
                        </div>
                    {% else %}
                        <div class="">{{ _("Quantity") }}: {{ line.quantity }}</div>
                    {% endif %}
                {% endif %}
            </div>

            <div class="d-flex justify-content-end">
                {% if product and shuup.urls.has_url("shuup:personal_wishlists") %}
                    {{ get_wishlist_button(product, request.customer) }}
                {% endif %}
                {% if line.can_delete %}
                    <button type="button"
                            class="btn delete-btn delete-line"
                            name="delete_{{ line.line_id }}"
                            title="{% trans %}Remove product from tote bag{% endtrans %}">
                        <svg viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M17.4079 22.0001H6.72333C5.94282 22.0001 5.24669 21.6979 4.70349 21.1202C4.18139 20.5637 3.90189 19.8534 3.90189 19.069V6.50183H20.2294V19.069C20.2294 19.8534 19.9551 20.5637 19.4278 21.1202C18.8898 21.6979 18.1884 22.0001 17.4079 22.0001ZM6.28034 8.88699V19.069C6.28034 19.2492 6.32253 19.3658 6.43328 19.4824C6.53875 19.5937 6.61786 19.6149 6.72861 19.6149H17.4132C17.5239 19.6149 17.603 19.5937 17.7085 19.4824C17.8193 19.3658 17.8615 19.2492 17.8615 19.069V8.88699H6.28034Z" fill="currentColor"/>
                        <path d="M15.2667 1L16.3214 2.97173C16.3214 2.97173 20.0394 2.97173 20.2346 2.97173C20.8674 2.97173 21.1364 3.43816 21.1364 3.9788C21.1364 4.49823 21.1364 5.35689 21.1364 5.35689H3C3 5.35689 3 4.49823 3 3.9788C3 3.43816 3.27423 2.97173 3.90181 2.97173C4.09694 2.97173 7.81492 2.97173 7.81492 2.97173L8.86966 1L15.2667 1Z" fill="currentColor"/>
                        <path d="M8.66925 18.645C8.08914 18.645 7.6145 18.168 7.6145 17.5849V11.0549C7.6145 10.4719 8.08914 9.99484 8.66925 9.99484C9.24936 9.99484 9.72399 10.4719 9.72399 11.0549V17.5902C9.72399 18.1733 9.25463 18.645 8.66925 18.645Z" fill="currentColor"/>
                        <path d="M11.9545 18.645C11.3744 18.645 10.8997 18.168 10.8997 17.5849V11.0549C10.8997 10.4719 11.3744 9.99484 11.9545 9.99484C12.5346 9.99484 13.0092 10.4719 13.0092 11.0549V17.5902C13.0092 18.1733 12.5398 18.645 11.9545 18.645Z" fill="currentColor"/>
                        <path d="M15.2403 18.645C14.6602 18.645 14.1855 18.168 14.1855 17.5849V11.0549C14.1855 10.4719 14.6602 9.99484 15.2403 9.99484C15.8204 9.99484 16.295 10.4719 16.295 11.0549V17.5902C16.295 18.1733 15.8257 18.645 15.2403 18.645Z" fill="currentColor"/>
                        </svg>
                    </button>
                {% endif %}
            </div>
        </div>
    </div>
{% endmacro %}

{% macro _render_basket_line_properties(properties) %}
    <div class="basket-line-properties">
        {% for property in properties %}
            <p class="basket-line-property">
                {% if property.name %}
                    <strong class="property-name">
                        {% if property.value %}
                            {{ _("{prop}:").format(prop=property.name) }}
                        {% else %}
                            {{ property.name }}
                        {% endif %}
                    </strong>
                {% endif %}
                {% if property.value %}
                    <span class="property-value">{{ property.value }}</span>
                {% endif %}
            </p>
        {% endfor %}
    </div>
{% endmacro %}

{% macro _render_supplier_info(supplier) %}
    <div class="supplier-info">
        {{ supplier.name }}
    </div>
{% endmacro %}

{% macro render_basket_supplier_info(supplier) %}
    {{ _render_supplier_info(supplier) }}
{% endmacro %}

{% macro render_used_coupons(basket) %}
    {% if basket.codes %}
        <div class="basket-used-codes">
            <p class="used-coupon-text">{% trans %}Coupons applied{% endtrans %}</p>
            {% for code in basket.codes %}
                <div class="basket-used-code">
                    <span class="basket-code">{{ code }}</span>
                    <button class="btn btn-primary basket-remove-code-btn" data-code="{{ code }}" type="button">
                        <i class="fa fa-trash"></i>
                    </button>
                </div>
            {% endfor %}
        </div>
    {% endif %}
{% endmacro %}

{% macro render_coupon_div(basket) %}
    <div class="basket-discount-code mt-6">
        <a class="btn btn-white btn-block collapsed coupon-toggle" href="#collapseCoupon" data-toggle="collapse">
            {% trans %}Enter coupon code{% endtrans %}
        </a>
        <div class="collapse" id="collapseCoupon">
            <div class="input-group mt-3">
                <input type="text"
                    class="form-control"
                    name="code"
                    id="discount-code"
                    placeholder="{% trans %}Coupon Code{% endtrans %}">
                <span class="input-group-btn">
                    <button type="submit"
                            id="submit-code"
                            class="btn btn-primary">
                        {% trans %}Submit{% endtrans %}
                    </button>
                </span>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro render_basket_summary(basket) %}
    {% if show_prices() and not xtheme.get("hide_prices") %}
        <div class="basket-summary">
            <div>{% trans %}Total{% endtrans %}</div>
            <div>{{ basket|total_price }}</div>
        </div>
    {% endif %}
{% endmacro %}

{% macro render_cart_saver() %}
    {% if request.person and shuup.urls.has_url("shuup:saved_cart.save") %}
        <div class="cart-saver">
            <a class="btn btn-primary cart-saver-toggle"
                href="#collapseSaveCart"
                data-toggle="collapse">
                {% trans %}Save tote bag{% endtrans %}
            </a>
            <div class="collapse" id="collapseSaveCart">
                <div class="input-group input-save-cart">
                    <input type="text"
                            id="cart-title"
                            class="form-control"
                            name="title"
                            placeholder="{% trans %}Tote Bag Title{% endtrans %}">
                    <span class="input-group-btn">
                        <button id="save-cart"
                                type="submit"
                                class="btn btn-primary">
                            {% trans %}Save{% endtrans %}
                        </button>
                    </span>
                </div>
                <div id="save-cart-status"></div>
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro proceed_to_checkout_button() %}
    <a href="{{ url('shuup:checkout') }}" class="btn btn-primary btn-block btn-checkout btn-lg-horizontal btn-lg-vertical">
        {% trans %}Checkout{% endtrans %}
    </a>
{% endmacro %}

{% macro continue_shopping_button() %}
    <a href="/" class="text-muted btn continue-shopping hidden-xs">
        {% trans %}Continue Shopping{% endtrans %}
    </a>
{% endmacro %}

{% macro render_empty_basket_actions() %}
    <a href="/" class="btn btn-primary">
        {% trans %}Back to Products{% endtrans %}
    </a>
{% endmacro %}

{% macro render_extrajs() %}
    <script type="text/javascript">
        $(function() {
            {{ update_quantity_js() }}
            {{ submit_coupon_code() }}
            {{ save_cart_js() }}
            {{ single_submit_form() }}
            {{ remove_basket_code() }}
        });
    </script>
{% endmacro %}

{% macro update_quantity_js() %}
    function update_totals(amt, price) {
        $("span#tote-bag-count").text("("+amt+")");
        $("div#basket-product-count").text(amt);
        $("span.canvas-nav__counter-badge").text(amt);
        formatted_price = price.toFixed(2).replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
        let summary = $(".basket-summary").find("div")[1]
        $(summary).text("$"+formatted_price);
    }

    function update_basket_quantities(send=true) {
        let total_items = 0
        let total_price = 0
        var data = {
                command: "update",
                return: window.location.pathname,
                csrfmiddlewaretoken: "{{ csrf_token }}",
        };
        $("#update_basket_form input[type=number]").each(function(){
            data[this.name] = this.value;
            num_items = parseInt(this.value);
            total_items += num_items
            let price = $(this).closest(".basket-line").find(".price").text()
            price = parseFloat(price.replace(/[^\d.]/g,''))
            total_price += price*num_items
        });
        if (send) {
            $.ajax({
                url : "/basket/",
                type: "POST",
                data: data,
                success : function(json) {
                    update_totals(total_items, total_price);
                },
                error : function(xhr,errmsg,err) {
                    console.log("Operation failed.");
                }
            });
        } else {
            update_totals(total_items, total_price);
        }
    };

    function checkEvent(e) {
        return (e.which == 13 || e.keyCode == 13 || e.key == "Enter");
    }

    $("#update_basket_form .quantity :input")
    .keydown(function(e) {
        if (checkEvent(e)) {
            e.preventDefault();
        }
    })
    .keyup(function(e) {
        if (checkEvent(e)) {
            $("#update_basket_form").submit();
        }
    })
    .change(function() {
        $("#update_basket_form").submit();
    });
        
    $('#update_basket_form').on('submit', function(event){
        event.preventDefault();
        update_basket_quantities();
    });

    function incrementQuantityAndUpdate(itemUpArrow) {
        let qty = $(itemUpArrow).prev('input');
        let current_value = parseInt(qty.val());
        qty.val(current_value+1);
        update_basket_quantities()
    }

    function decrementQuantityAndUpdate(itemDownArrow) {
        let qty = $(itemDownArrow).next('input');
        let current_value = parseInt(qty.val());
        qty.val(Math.max(current_value-1, 0));
        update_basket_quantities()
    }

    function deleteBasketLine(itemDeleteButton) {
        var data = {
            command: "update",
            return: window.location.pathname,
            csrfmiddlewaretoken: "{{ csrf_token }}",
        }
        data[itemDeleteButton.name] = ""
        $.ajax({
            url : "/basket/",
            type: "POST",
            data: data,
            success : function(json) {
                //update_totals(total_items);
                $(itemDeleteButton.closest(".basket-line")).remove();
                update_basket_quantities(send=false);
            },
            error : function(xhr,errmsg,err) {
                console.log("Operation failed.");
            }
        });
    }

    function updateWishlistFromToteBag(shopProductId, itemDeleteButton) {
    $.ajax({
            url: `/wishlist/default/product/${shopProductId}/`,
            data: {return: window.location.pathname, csrfmiddlewaretoken: "{{ csrf_token }}"},
            method: "POST",
            success: function(resp) {
                updateWishlist();
                deleteBasketLine(itemDeleteButton);
            },
            error : function(xhr,errmsg,err) {
                console.log("Operation failed.");
            }
        });
    }

    $("#navigation-basket-partial").on("click", '.basket-quantity__minus', function(){
        decrementQuantityAndUpdate(this);
    });

    $("#navigation-basket-partial").on("click", '.basket-quantity__plus', function(){
        incrementQuantityAndUpdate(this);
    });

    $("#navigation-basket-partial").on("click", '.delete-line', function(){
        deleteBasketLine(this);
    });

    $("#navigation-basket-partial").on("click", '.add-to-wishlist', function(){
        let itemDeleteButton = $(this).closest(".basket-line__row").find(".delete-line")[0];
        let shopProductId = $(this).attr("data-shop-product-id");
        updateWishlistFromToteBag(shopProductId, itemDeleteButton);
        // Cancel the usual wishlist form submit.
        return false;
    });
{% endmacro %}

{% macro remove_basket_code() %}
    $(".basket-remove-code-btn").click(function(evt) {
        var code = $(evt.currentTarget).data("code");
        if (code) {
            var data = {
                "command": "remove_campaign_code",
                "code": code
            };
            $.ajax({
                url: "",
                method: "POST",
                data: data,
                success: function(response) {
                    if (response.ok) {
                        location.reload();
                    } else {
                        alert("{% trans %}Error!{% endtrans %} {% trans %}Invalid coupon code.{% endtrans %}")
                    }
                },
                error: function() {
                    alert("{% trans %}Error!{% endtrans %} {% trans %}Removing a coupon failed.{% endtrans %}")
                }
            });
        }
    });
{% endmacro %}

{% macro submit_coupon_code() %}
    function showErrorMessage(msg) {
        if(typeof window.flashMessage !== 'undefined') {
            flashMessage('alert-danger', '', msg);
        } else {
            alert(msg);
        }
    }
    $("#submit-code").click(function(e){
        e.preventDefault();
        const coupon = $("#discount-code").val();

        if (coupon.length) {
            // ajax request to command
            const data = {
                "command": "add_campaign_code",
                "code": coupon
            };

            $.ajax({
                url: "",
                method: "POST",
                data: data,
                success: function(response) {
                    if (response.ok) {
                        location.reload();
                    }
                    else {
                        showErrorMessage("{% trans %}Error!{% endtrans %} {% trans %}Coupon is not available.{% endtrans %}")
                    }
                },
                error: function() {
                    showErrorMessage("{% trans %}Error!{% endtrans %} {% trans %}Adding coupon failed.{% endtrans %}")
                }
            });
        }
    });
{% endmacro %}

{% macro save_cart_js() %}
    {% if shuup.urls.has_url("shuup:saved_cart.save") %}
        $("#save-cart").click(function(e){
            e.preventDefault();
            var title = $("#cart-title").val();
            $("#save-cart-status").empty();
            $.ajax({
                url: "{{ url('shuup:saved_cart.save') }}",
                method: "POST",
                data: {
                    title: title,
                    csrfmiddlewaretoken: "{{ csrf_token }}"
                },
                success: function(response) {
                    $("#save-cart-status").append("<p>" + "{% trans %}Success!{% endtrans %} {% trans %}Cart saved.{% endtrans %}" + "</p>");
                },
                error: function(e) {
                    $("#save-cart-status").append("<p>" + "{% trans %}Error!{% endtrans %}" + e.responseJSON.error + "</p>");
                }
            });
        });
    {% endif %}
{% endmacro %}

{% macro single_submit_form() %}
    window.singleSubmitForm = function($form) {
        var canSubmit = true;
        $form.submit(function() {
            if(canSubmit) {
                canSubmit = false;
            }
            else {
                return false;
            }
        });
    };
    singleSubmitForm($("#update_basket_form"));
{% endmacro %}

{% macro add_product_to_cart(main_class="basket-message") %}
    <div class="{{ main_class }}">
        <div class="text-wrap">
            <div class="success-msg">
                <i class="fa fa-check" aria-hidden="true"></i>
                <p>{% trans %}Product added to tote bag{% endtrans %}</p>
            </div>
            <div class="error-msg">
                <i class="fa fa-warning" aria-hidden="true"></i>
                <p id="error-msg"></p>
            </div>
        </div>
    </div>
    {{ product_to_basket_js(main_class) }}
{% endmacro %}

{% macro product_to_basket_js(main_class) %}
    <script>
        function updateNavigationBasket() {
            $.ajax({
                url: "{{ url('shuup:xtheme_extra_view', view='basket_partial') }}",
                method: "GET",
                success: function(basket_html) {
                    var $basket_html = $(basket_html);
                    $basket_html.find("input[name='return']").each(function(idx, el) {
                        $(el).val("{{ request.path }}");
                    });

                    $("#navigation-basket-partial").html($basket_html);

                    // Update counter badge values
                    var basketCount = $('#basket-product-count').html();
                    var basketCountTargets = $('.basket-counter-badge');
                    basketCountTargets.each(function() {
                        $(this).html(basketCount);
                    });
                }
            });
        }

        function handleMessageHiding(cover, btn) {
            // Remove spinner icon from the button and enable it again
            $("#btn-spinner").remove();
            btn.attr("disabled", false);

            setTimeout(function() {
                // Hide the message and the modal after 3 seconds
                cover.removeClass("in error");
                cover.removeAttr("role");
            }, 3000);
        }

        function handleError(cover, errorMsg, btn) {
            // change to error message
            cover.addClass('in error');

            var msg = "{% trans %}There was an error adding the product to the basket{% endtrans %}";
            cover.find("#error-msg").text(errorMsg ? errorMsg : msg);

            handleMessageHiding(cover, btn);
        }

        function handleSuccess(cover, btn) {
            // show the message
            cover.addClass("in");

            updateNavigationBasket();

            handleMessageHiding(cover, btn);
        }

        function addToBasket(form) {
            var cover = $(".{{ main_class }}");

            cover.removeClass("in error"); // Reset if clicked multiple times in a row
            cover.attr("role", "alert");

            var btn = $(form).find("button[id*='add-to-cart']");
            if (!btn.length) {
                btn = $(form).find("button[class*='add-to-cart']")
            }

            btn.prepend("<i id='btn-spinner' class='fa fa-spin fa-spinner'></i>").attr("disabled", true);

            $.ajax({
                url: form.attr("action"),
                method: "POST",
                data: form.serializeArray(),
                success: function(response) {
                    if(response.error) {
                        handleError(cover, response.error, btn);
                        return;
                    }
                    handleSuccess(cover, btn);
                },
                error: function() {
                    handleError(cover, null, btn);
                }
            });
        }

        $(document).ready(function() {
            $(document).on("submit", "form.add-to-basket", function(e) {
                e.preventDefault();
                addToBasket($(this));
            });
        });
    </script>
{% endmacro %}
